require 'mongoid'
require 'mongoid/state_bits'

class Post
  include Mongoid::Document
  include Mongoid::StateBits
  state_bits %w{deleted commentable original}
end

class User
  include Mongoid::Document
  include Mongoid::StateBits
  state_bits admin: true, deleted: false
end

describe Mongoid::StateBits do 
  it "should generate specified fields" do
    p = Post.new
    expect(p.commentable).to eq(false)
    p.commentable = true
    expect(p.commentable).to eq(true)
  end

  it "state_bits field sholud record state bits" do
    p = Post.new
    p.original = true
    p.commentable = false
    p.deleted = true
    expect(p.state_bits).to eq(5)
  end

  it "supports default value definition" do
    u = User.new
    expect(u.admin).to eq(true)
    expect(u.deleted).to eq(false)
  end
end